package net.pricefx.common.dto.rat;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import net.pricefx.common.api.InputType;
import net.pricefx.common.api.PriceFxInterface;

import java.util.Objects;

/**
 * Created by petercipov on 25/04/16.
 */
public class RATPlaceholder {
    private final String uniqueName;
    private final InputType type;

    @JsonCreator
    public RATPlaceholder(
        @JsonProperty(PriceFxInterface.FIELD_UNIQUENAME) String uniqueName,
        @JsonProperty(PriceFxInterface.FIELD_TYPE) InputType type) {
        Objects.requireNonNull(uniqueName);
        Objects.requireNonNull(type);
        this.uniqueName = uniqueName;
        this.type = type;
    }

    public String getUniqueName() {
        return uniqueName;
    }

    public InputType getType() {
        return type;
    }


}
