package net.pricefx.logic.core.model;

import net.pricefx.common.api.IFormulaNature;
import net.pricefx.common.api.WorkflowFormulaNature;
import net.pricefx.common.api.WorkflowType;
import net.pricefx.restapiclient.model.BaseMap;

import static net.pricefx.common.api.PriceFxInterface.FIELD_UNIQUENAME;
import static net.pricefx.common.api.PriceFxInterface.FIELD_WFE_WORKFLOWTYPE;

public class WorkflowFormula extends AbstractFormula {

    public WorkflowFormula() {
    }

    @Override
    public WorkflowFormulaElement createElement() {
        return new WorkflowFormulaElement();
    }

    @Override
    public WorkflowFormulaElement createElement(BaseMap element) {
        return fromObject(element, WorkflowFormulaElement.class);
    }

    @Override
    public final boolean isPricingLogic() {
        return false;
    }

    @Override
    public final boolean isWorkflowLogic() {
        return true;
    }

    @Override
    public IFormulaNature getFormulaNatureObject() {
        return WorkflowFormulaNature.getViaDBValue(getFormulaNature());
    }

    public final String getWorkflowTypeStr() {
        String workflowTypeStr = getStringValue(FIELD_WFE_WORKFLOWTYPE);

        // TODO this is due to backwards compatibility. To be removed one day...
        if (workflowTypeStr == null) {
            workflowTypeStr = getStringValue(FIELD_UNIQUENAME);
        }

        return workflowTypeStr;
    }

    public final WorkflowType getWorkflowType() {
        return WorkflowType.getViaDBValue(getWorkflowTypeStr());
    }

    public final void setWorkflowType(String workflowTypeStr) {
        setStringValue(FIELD_WFE_WORKFLOWTYPE, workflowTypeStr);
    }
}

